/* Frame.h created by ovidiu on Sun 23-Mar-1997 */

#import <Foundation/NSObject.h>

@class NSString;
@class NSMutableArray;

@class GdbDisplayController;
@class Stack;
@class Frame;
@class Variable;

@interface Frame : NSObject
{
  Stack* stack;
  int frameNumber;
  int frameAddress;
  int startLine;
  int endLine;
  NSString* functionName;
  NSString* fileName;
  NSMutableArray* variables;
  BOOL validVariables;
}

+ (Frame*)frameWithAnnotation:(NSString*)annotation stack:(Stack*)stack;

- (void)setFilename:(NSString*)file startLine:(int)line endLine:(int)endLine;

- (int)frameNumber;
- (NSString*)functionName;
- (NSString*)fileName;
- (int)numberOfVariables;
- (int)startLine;
- (int)endLine;
- (GdbDisplayController*)gdbController;
- (Variable*)variableAtIndex:(int)index;

- (void)invalidateCurrentVariables;
- (BOOL)variablesAreValid;

- (void)getVariablesFromGDB;

- (void)selectLineInFile;

@end
