/* OFInfoManager.h
 *
 * <Short class description goes here>
 *
 * Usage: <short usage description goes here>
 *
 *
 * Written by:	   Thomas Engel
 * Created on:	   16-Feb-1997 (Copyleft)
 */


#import <AppKit/AppKit.h>

enum
{
    OFInfoShowingAppIcon = 1,
	OFInfoShowingCompanyIcon,
    OFInfoShowingDeveloperIcon,
    OFInfoShowingDesignerIcon,
    OFInfoShowingAnimatedIcon
};

@interface OFInfoManager : NSObject

/*" Overview:

"*/

/*" Description:

"*/

{
    id		panel;
    id		desktopView;
    id		noteImageView;
    id		clipImageView;

    int		_currentIconState;

    id		appButton;				// Buttons containing the images.
    id		companyButton;
    id		developerButton;
    id		designerButton;

    id		noteSwitchTimer;		// Timer for automatic note switches. 

	// The animation stuff is not yet implemented...this is for animating certain parts of the panel.
   
	BOOL	animationRunning;
    id		currentAnimator;
    id		animatorList;			// List of animators which would perform a certain animation perhaps set a OFAnimatorProtocol
}

- (id)init;
- (void)makeKeyAndOrderFront:sender;

// Switching between icons. Triggered by buttons inside the Panel.

- (void)switchToNextIcon:sender;
- (void)switchToAppIcon:sender;
- (void)switchToCompanyIcon:sender;
- (void)switchToDeveloperIcon:sender;
- (void)switchToDesignerIcon:sender;

- (void)_switchTo:(int)aStyle using:aButton;
- (void)_placeNewNoteImage:(NSTimer *)ourTimer;
- (void)_sheduleNextTimedSwitch;

- (void)startRandomAnimation:sender;

// Delegate methods to stop a animations properly even when our window closes.
// Attention. We must be the animators delegate and the windows delegate.

- (void)animationDidStop:sender;
- (void)windowDidClose:(NSNotification *)notification;
- (void)windowDidMiniaturize:(NSNotification *)notification;

@end


/*" History:

  	11-Mar-1997	Revised the code to work with the new "paper-clip" design.

 	16-Feb-1997	Created this class interface.
"*/

/*" Bugs:

	00000	No bugs known.
"*/